( ;  4th_86 version 4.01 -- as of February 1994 )

off printload
on redefine

( 24th, March 1993 - 4th_86 version 4.01 - MFB ) 

(
******************************************************
*           T U T O R I A L   C O D E                *
******************************************************
)

 code 4b@  
	mov	ax,cs
	add	ax,3000h
	mov	ds,ax
	pop	bx
	mov	dl,[bx]
	mov	dh,0
	push	dx
	mov	ax,cs
	mov	ds,ax
;

code 4b!
	mov	ax,cs
	add	ax,3000h
	mov	ds,ax
	pop	bx
	pop	dx
	mov	[bx],dl
	mov	ax,cs
	mov	ds,ax
;

( * following no longer needed here -- permanently within 4th_86 
        left in as illustration of how to write in line
              assembly code with labels 

*code secdelay
*
*	pop	ax
*	mov	bx,0
*
*	push	ax
*	mov	ah,2ch
*	int	21h
*	pop	ax
*
*	mov	bl,dh
*	add	bl,al
*	cmp	bl,3bh
*	mov	cx,0
*
*	ifnc
*	sub	bl,3bh
*	then
*
*| dloop
*	mov	bh,dh
*	push	cx
*	mov	ah,2ch
*	int	21h
*	pop	cx
*	cmp	bh,dh
*
*	ifnz
*	inc	cx
*	push	dx
*	push	bx 
*	push	cx
*	push	cx
*	:enter  dup 9 > if 8 .c then 8 8 .c .c  . :exit
*	pop	cx
*	pop	bx 
*	pop	dx
*
*	then
*	cmp	bl,dh
*
*	jnz	dloop
*labels
*;
*
* )

2 block splitv		( stores vertical co-ordinate of screen split )
2 block wflag		( 0 if W1 has been used --- 1 if W2 has been used )

( **********
** create two windows 
**	word WINDOW is in 7BASIC04.ASM
**
** 0 win1 will initialise window
** 5 win1 will scroll window up 5 lines ** 
** xx05 win1 will scroll window down 5 lines
** where xx is any non-zero byte 
********** )

	( Note -- TOS is # lines to scroll )

	: win1 1eh ( color )
	      0 0  ( top left corner )
	  77 splitv @   ( bottom right corner )
		window ;

	: win2 4eh  ( color )
	   0 splitv @ 1+ ( top left corner )
	      77 24   ( bottom right corner )
		 window ;

( **********
** initialise windows
** W1 is top section of screen -- W2 is lower
********** )

	: setw1 0 splitv @ 1- gotoxy 
		1eh gcolr ! ( window 1 color ) ;

	: setw2 0 23 gotoxy 
		4eh gcolr ! ( window 2 color ) ;

	: w1 0 wflag ! setw1 ;
	: w2 1 wflag ! setw2 ;

( **********
** use ----  SPLITAT N where N is Y co-ordinate
********** )

	: splitat word val ( dup ) 
	dup 22 > if drop 22 else dup 1 < if drop 1 then then splitv ! 
	0024h win2 2424h win1 
	wflag @ if setw2 else setw1 then ;

( **********
** print text into window 
********** )

	: .cwin  getxy drop ( unwanted X value)
	dup ( y value ) splitv @  = if ( bottom of upper window )
	      1 win1  0 splitv @ 1 - gotoxy 
			             then  
            23 > if 1 win2 0 23 gotoxy   ( bottom of lower window )
		then  gcout ; 

( **********
** 	equivalent to LINK -- but specific to this file 
********** )

	: linkup
	over - 3 - swap dup e9h swap b! 1+ ! ;

( **********
** equivalent to UNLINK -- but specific to this file 
********** )

	: breaklink
	over - 3 - swap dup e8h swap b! 1+ ! ;

( **********
** replace    .C   CONLIN   GETCHR   
** with     .CWIN  MAKELIN  NGETCHR
** 
** NOTE: .C [ equivalent to PUTCHR ] uses DOS Int21 function 1 
** 		and has no color abilities
**      CONLIN uses DOS Int21 bufered input function 0A Hex 
** 		and has no function key detection
**      GETCHR uses Int21 function 2 
** 		and echoes input automatically with no color
** 	----------------------------------------------------
**       .CWIN source code is in this file
** 	  MAKELIN uses Int21 function 8 with Int10 
** 		for color echo via word GCOUT
**        NGETCHR uses Int21 function 8 with .C [ linked to .CWIN ]
** 		for color echo
** 	----------------------------------------------------
** 	GCOUT and WINDOW source is in 7BASIC04.ASM
** 	MAKELIN and CONLIN source is in 7CLI04.4TH 
** 	NGETCHR PUTCHR GETCHR source is in 7OSIB04.4TH
** 	----------------------------------------------------
********** )

	: makelink
		' .c ' .cwin linkup   
			' conlin ' makelin linkup  
		 		' getchr ' ngetchr linkup 
					  15 win2  ;

	: colortext
		' .c ' gcout linkup   
			' conlin ' makelin linkup  
		 		' getchr ' ngetchr linkup 
					1eh gcolr ! ;


( **********
** replace the CALL COLON entry points to
** .C   CONLIN    GETCHR
********** )

	 : fullscreen
		' .c ' colon breaklink   
			' conlin ' colon breaklink
		 		' getchr ' colon breaklink 
		  ' ermsg ' ftwofwd 3 + !
		  ' ermsg ' fonefwd 3 + !
						cls logo ;

	 : plaintext
		' .c ' colon breaklink   
			' conlin ' colon breaklink
		 		' getchr ' colon breaklink ;

10 block fcbuf
2 block fcflag
2 block tcbptr
2 block tcbflg
2 block thead
2 block othead

( **********
** load tutorial file into memory
********** )

	: tutload 0 thead ! ( word ) 1 sysopen dup %mfcb !

     repeat dup sysrbyte ( dup 0= eoflg B! )
             drop dup 0= 0= while ( test returned sysrbyte flag for eof )
                 thead @ 4b!  1 thead +!  
			endwhile drop drop  0 thead ! %mfcb @ sysclose ;

	: tload word tutload ;

( **********
********** )

	: tcopy  dup 7 = 0=  ( 7 is ctl-G )
		if tcbptr  @ b! 1 tcbptr +!
			conbuf 1+ dupb@ 1+ swap  b!
		else drop 0dh tcbptr @ b! 
			0 tcbflg !  0 conip !  
		then ;
( **********
********** )

 : execstrg 
    dup last  @ find dup 0 = if val else
		2dupb@ + 2+ 2@ swap drop exec 
                                   	 then ;


	: fcopy  dup 7 = 0=  ( 7 is ctl-G )
		if tcbptr  @ b! 1 tcbptr +! 
			fcbuf dupb@ 1+ swap  b!
		else drop 
			0 tcbflg !  
			fcflag @ if 
	wflag @ if setw2 else setw1 then fcbuf execstrg
	wflag @ if setw1 else setw2 then
				else fcbuf val splitv ! 
				 0024h win2 2424h win1 setw1
						then
					then ;
( **********
********** )

	: doshow 0 wflag @ if win1 setw1 else  win2 setw2 then

     repeat thead @ 4b@ 1 thead +! 
             dup "$"  = 0= while  ( $ represents end of screen )

	 case  6 of 0 conbuf 1+ tcbptr ! 1 tcbflg !  endof 
	       5 of 0ffh fcbuf tcbptr ! 2 tcbflg ! endof 
	       4 of 0ffh fcbuf tcbptr ! 3 tcbflg ! endof 
	       3 of  23h 8 tcbflg !  endof  
			 endcase 

	tcbflg @   case 0 of .c endof 
	      		1 of  tcopy endof 
	      		2 of  fcopy  1 fcflag ! endof 
			3 of  fcopy  0 fcflag !  endof 
			8 of 8 = if  0 tcbflg ! then endof 
				endcase 

				endwhile drop  
	( wflag @ if ) setw2 ( else setw1 then ) ; 

( **********
********** )

	: show+ ( 12 splitv ! ) 1102h win2 thead @ othead ! 

	    repeat thead @ dup 1+ thead ! 4b@ 
	    	dup "~" = 0= while  
			2 = if  0 thead !  
			    then  endwhile  
				drop doshow ;
( **********
********** )

	: show- ( 12 splitv !  ) 1102h win2 othead @ thead !  

		repeat thead @ 
		dup 0= if drop 2 win2 show+ return 
			then
		dup 1 - thead ! 4b@ 
	     	    "~" = 0= while endwhile 
				thead @ dup 2 + thead ! othead ! 
					doshow ;

( **********
********** )

	: splitscreen 0 tcbflg !
	12 splitv ! makelink 
	     0 win1    0 win2     

	wflag @ if setw2 else setw1 then ( make w2 prompt window ) ;
		

	: w1init 0 win1 ;
	: w2init 0 win2 ;

( **********
********** )

 : help  " -- please wait while  tutorial.txt loads -- " ." crlf
	" tutorial.txt"  tutload   
	  ' show+ ' ftwofwd 3 + !
	  ' show- ' fonefwd 3 + !
		splitscreen   show+ ;


	synonym split splitscreen
	synonym unsplit fullscreen
